Bug 1157888 - (CVE-2019-19579) VUL-0: CVE-2019-19579: xen: XSA-306 Device quarantine for alternate pci assignment methods
(CVE-2019-19579)
VUL-0: CVE-2019-19579: xen: XSA-306 Device quarantine for alternate pci assig...
Status: RESOLVED FIXED
Classification: Novell Products
Product: SUSE Security Incidents
Classification: Novell Products
Component: Incidents
unspecified
Other Other
: P3 - Medium : Normal
: ---
Assigned To: Security Team bot
Security Team bot
https://smash.suse.de/issue/248051/
CVSSv3.1:SUSE:CVE-2019-19579:6.9:(AV:...
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2019-11-27 12:44 UTC by Alexander Bergmann
Modified: 2022-05-05 11:36 UTC (History)
6 users (show)

See Also:
Found By: ---
Services Priority:
Business Priority:
Blocker: ---
Marketing QA Status: ---
IT Deployment: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Comment 1 Alexander Bergmann 2019-11-27 12:45:27 UTC
https://xenbits.xen.org/xsa/advisory-306.html
Comment 3 Robert Frohl 2019-12-05 15:22:51 UTC
            Xen Security Advisory CVE-2019-19579 / XSA-306
                              version 3

        Device quarantine for alternate pci assignment methods

UPDATES IN VERSION 3
====================

CVE assigned.

ISSUE DESCRIPTION
=================

XSA-302 relies on the use of libxl's "assignable-add" feature to
prepare devices to be assigned to untrusted guests.

Unfortunately, this is not considered a strictly required step for
device assignment.  The PCI passthrough documentation on the wiki
describes alternate ways of preparing devices for assignment, and
libvirt uses its own ways as well.  Hosts where these "alternate"
methods are used will still leave the system in a vulnerable state
after the device comes back from a guest.

IMPACT
======

An untrusted domain with access to a physical device can DMA into host
memory, leading to privilege escalation.

VULNERABLE SYSTEMS
==================

Only systems where guests are given direct access to physical devices
capable of DMA (PCI pass-through) are vulnerable.  Systems which do
not use PCI pass-through are not vulnerable.

Only systems which use "alternate" methods to assign devices to pciback
before assignment are vulnerable.  These methods include:
 - Assigning devices on the Linux command-line using `xen-pciback.hide`
 - Assigning devices via xen-pciback module parameters
 - Assigning devices manually via sysfs
 - Assigning devices using libvirt

Systems which use `xl pci-assignable-add` or
libxl_device_pci_assignable_add, or have the assignable state handled
automatically via setting the `seize` parameter, are not affected.

MITIGATION
==========

For xl and libvirt, before assigning a device to a guest, manually run
`xl pci-assignable-add`.  This will quarantine the device even if the
device has already been assigned to pciback by one of the alternate
methods.  This may also work for other libxl-based toolstacks,
depending on the particular implementation.

CREDITS
=======

This issue was discovered by Marek Marczykowski-Górecki of Invisible
Things Lab.

RESOLUTION
==========

Applying the appropriate attached patch resolves this issue.

Note that this patch will quarantine the device after the domain is
destroyed by default.  It must be un-quarantined before it can be used
by domain 0 again.  This can be done by executing `xl
pci-assignable-remove`.  This will be effective even if the device was
assigned to pciback with one of the alternate methods.

xsa306.patch           xen-unstable
xsa306-4.12.patch      Xen 4.12.x
xsa306-4.11.patch      Xen 4.11.x, Xen 4.10.x
xsa306-4.9.patch       Xen 4.9.x, Xen 4.8.x

$ sha256sum xsa306*
07468dcdfbe34b794fd0618bce7d6d1edb6b10b234dccf1e5dd1f1120a0affe7  xsa306.meta
3534ec46f03bb8dac3011e0e3739fc75400559078e4361bbe5385d97b7892650  xsa306.patch
426e32bfa7d7787fe6778685e623966f8762857f7920443a0ca73347df9d6624  xsa306-4.9.patch
b00e58c9f96b0ff654dfd4904c675a54356148af718eb9b2adca0253b900dfc1  xsa306-4.11.patch
69857d08969903452fbf009905a145e06a5aef9966e969de9fbb22e62c557ffd  xsa306-4.12.patch
$

DEPLOYMENT DURING EMBARGO
=========================

Deployment of the patches and/or mitigations described above (or
others which are substantially similar) is permitted during the
embargo, even on public-facing systems with untrusted guest users and
administrators.

But: Distribution of updated software is prohibited (except to other
members of the predisclosure list).

Predisclosure list members who wish to deploy significantly different
patches and/or mitigations, please contact the Xen Project Security
Team.


(Note: this during-embargo deployment notice is retained in
post-embargo publicly released Xen Project advisories, even though it
is then no longer applicable.  This is to enable the community to have
oversight of the Xen Project Security Team's decisionmaking.)

For more information about permissible uses of embargoed information,
consult the Xen Project community's agreed Security Policy:
  http://www.xenproject.org/security-policy.html
Comment 4 Swamp Workflow Management 2019-12-06 20:11:14 UTC
SUSE-RU-2019:3199-1: An update that has three recommended fixes can now be installed.

Category: recommended (moderate)
Bug References: 1027519,1157047,1157888
CVE References: 
Sources used:
SUSE Linux Enterprise Software Development Kit 12-SP5 (src):    xen-4.12.1_08-3.5.4
SUSE Linux Enterprise Server 12-SP5 (src):    xen-4.12.1_08-3.5.4

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 6 Swamp Workflow Management 2019-12-13 23:11:52 UTC
SUSE-SU-2019:3297-1: An update that fixes 15 vulnerabilities is now available.

Category: security (important)
Bug References: 1152497,1154448,1154456,1154458,1154460,1154461,1154464,1155945,1157888,1158003,1158004,1158005,1158006,1158007
CVE References: CVE-2018-12207,CVE-2019-11135,CVE-2019-18420,CVE-2019-18421,CVE-2019-18422,CVE-2019-18423,CVE-2019-18424,CVE-2019-18425,CVE-2019-19577,CVE-2019-19578,CVE-2019-19579,CVE-2019-19580,CVE-2019-19581,CVE-2019-19582,CVE-2019-19583
Sources used:
SUSE OpenStack Cloud Crowbar 8 (src):    xen-4.9.4_06-3.59.1
SUSE OpenStack Cloud 8 (src):    xen-4.9.4_06-3.59.1
SUSE Linux Enterprise Server for SAP 12-SP3 (src):    xen-4.9.4_06-3.59.1
SUSE Linux Enterprise Server 12-SP3-LTSS (src):    xen-4.9.4_06-3.59.1
SUSE Linux Enterprise Server 12-SP3-BCL (src):    xen-4.9.4_06-3.59.1
SUSE Enterprise Storage 5 (src):    xen-4.9.4_06-3.59.1
SUSE CaaS Platform 3.0 (src):    xen-4.9.4_06-3.59.1
HPE Helion Openstack 8 (src):    xen-4.9.4_06-3.59.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 7 Swamp Workflow Management 2019-12-16 17:13:44 UTC
SUSE-SU-2019:3310-1: An update that fixes 10 vulnerabilities is now available.

Category: security (important)
Bug References: 1154460,1154461,1154464,1157888,1158003,1158004,1158005,1158006,1158007
CVE References: CVE-2019-18422,CVE-2019-18423,CVE-2019-18424,CVE-2019-19577,CVE-2019-19578,CVE-2019-19579,CVE-2019-19580,CVE-2019-19581,CVE-2019-19582,CVE-2019-19583
Sources used:
SUSE Linux Enterprise Software Development Kit 12-SP4 (src):    xen-4.11.3_02-2.20.1
SUSE Linux Enterprise Server 12-SP4 (src):    xen-4.11.3_02-2.20.1
SUSE Linux Enterprise Desktop 12-SP4 (src):    xen-4.11.3_02-2.20.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 8 Swamp Workflow Management 2019-12-16 17:15:20 UTC
SUSE-SU-2019:3309-1: An update that fixes 9 vulnerabilities is now available.

Category: security (important)
Bug References: 1154460,1154464,1157888,1158003,1158004,1158005,1158006,1158007
CVE References: CVE-2019-18422,CVE-2019-18423,CVE-2019-19577,CVE-2019-19578,CVE-2019-19579,CVE-2019-19580,CVE-2019-19581,CVE-2019-19582,CVE-2019-19583
Sources used:
SUSE Linux Enterprise Module for Server Applications 15 (src):    xen-4.10.4_08-3.28.1
SUSE Linux Enterprise Module for Basesystem 15 (src):    xen-4.10.4_08-3.28.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 9 Swamp Workflow Management 2019-12-18 23:12:31 UTC
SUSE-SU-2019:3338-1: An update that solves 7 vulnerabilities and has two fixes is now available.

Category: security (important)
Bug References: 1027519,1152497,1157047,1157888,1158003,1158004,1158005,1158006,1158007
CVE References: CVE-2019-19577,CVE-2019-19578,CVE-2019-19579,CVE-2019-19580,CVE-2019-19581,CVE-2019-19582,CVE-2019-19583
Sources used:
SUSE Linux Enterprise Module for Server Applications 15-SP1 (src):    xen-4.12.1_06-3.9.1
SUSE Linux Enterprise Module for Open Buildservice Development Tools 15-SP1 (src):    xen-4.12.1_06-3.9.1
SUSE Linux Enterprise Module for Basesystem 15-SP1 (src):    xen-4.12.1_06-3.9.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 13 Swamp Workflow Management 2020-02-06 14:14:54 UTC
SUSE-SU-2020:0334-1: An update that fixes 13 vulnerabilities is now available.

Category: security (important)
Bug References: 1152497,1154448,1154456,1154458,1154461,1155945,1157888,1158003,1158004,1158005,1158006,1158007,1161181
CVE References: CVE-2018-12207,CVE-2019-11135,CVE-2019-18420,CVE-2019-18421,CVE-2019-18424,CVE-2019-18425,CVE-2019-19577,CVE-2019-19578,CVE-2019-19579,CVE-2019-19580,CVE-2019-19581,CVE-2019-19583,CVE-2020-7211
Sources used:
SUSE OpenStack Cloud 7 (src):    xen-4.7.6_06-43.59.1
SUSE Linux Enterprise Server for SAP 12-SP2 (src):    xen-4.7.6_06-43.59.1
SUSE Linux Enterprise Server 12-SP2-LTSS (src):    xen-4.7.6_06-43.59.1
SUSE Linux Enterprise Server 12-SP2-BCL (src):    xen-4.7.6_06-43.59.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 14 Swamp Workflow Management 2020-02-17 17:13:32 UTC
SUSE-SU-2020:0388-1: An update that fixes 25 vulnerabilities is now available.

Category: security (important)
Bug References: 1115045,1126140,1126141,1126192,1126195,1126196,1126201,1135905,1143797,1145652,1146874,1149813,1152497,1154448,1154456,1154458,1154461,1155945,1157888,1158003,1158004,1158005,1158006,1158007,1161181
CVE References: CVE-2018-12207,CVE-2018-19965,CVE-2019-11135,CVE-2019-12067,CVE-2019-12068,CVE-2019-12155,CVE-2019-14378,CVE-2019-15890,CVE-2019-17340,CVE-2019-17341,CVE-2019-17342,CVE-2019-17343,CVE-2019-17344,CVE-2019-17347,CVE-2019-18420,CVE-2019-18421,CVE-2019-18424,CVE-2019-18425,CVE-2019-19577,CVE-2019-19578,CVE-2019-19579,CVE-2019-19580,CVE-2019-19581,CVE-2019-19583,CVE-2020-7211
Sources used:
SUSE Linux Enterprise Server for SAP 12-SP1 (src):    xen-4.5.5_28-22.64.1
SUSE Linux Enterprise Server 12-SP1-LTSS (src):    xen-4.5.5_28-22.64.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 15 Swamp Workflow Management 2020-06-16 19:12:24 UTC
SUSE-SU-2020:1630-1: An update that fixes 12 vulnerabilities is now available.

Category: security (important)
Bug References: 1157888,1158003,1158004,1158005,1158006,1158007,1161181,1167152,1168140,1168142,1169392,1172205
CVE References: CVE-2019-19577,CVE-2019-19578,CVE-2019-19579,CVE-2019-19580,CVE-2019-19581,CVE-2019-19583,CVE-2020-0543,CVE-2020-11739,CVE-2020-11740,CVE-2020-11741,CVE-2020-11742,CVE-2020-7211
Sources used:
SUSE OpenStack Cloud Crowbar 8 (src):    xen-4.9.4_06-3.62.1
SUSE OpenStack Cloud 8 (src):    xen-4.9.4_06-3.62.1
SUSE Linux Enterprise Server for SAP 12-SP3 (src):    xen-4.9.4_06-3.62.1
SUSE Linux Enterprise Server 12-SP3-LTSS (src):    xen-4.9.4_06-3.62.1
SUSE Linux Enterprise Server 12-SP3-BCL (src):    xen-4.9.4_06-3.62.1
SUSE Enterprise Storage 5 (src):    xen-4.9.4_06-3.62.1
HPE Helion Openstack 8 (src):    xen-4.9.4_06-3.62.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 17 Swamp Workflow Management 2020-08-04 19:40:00 UTC
SUSE-SU-2020:14444-1: An update that fixes 16 vulnerabilities is now available.

Category: security (important)
Bug References: 1152497,1154448,1154456,1154458,1154461,1155945,1157888,1158004,1158005,1158006,1158007,1161181,1163019,1168140,1169392,1174543
CVE References: CVE-2018-12207,CVE-2019-11135,CVE-2019-18420,CVE-2019-18421,CVE-2019-18424,CVE-2019-18425,CVE-2019-19577,CVE-2019-19578,CVE-2019-19579,CVE-2019-19580,CVE-2019-19583,CVE-2020-11740,CVE-2020-11741,CVE-2020-11742,CVE-2020-7211,CVE-2020-8608
JIRA References: 
Sources used:
SUSE Linux Enterprise Server 11-SP4-LTSS (src):    xen-4.4.4_42-61.52.1
SUSE Linux Enterprise Debuginfo 11-SP4 (src):    xen-4.4.4_42-61.52.1

NOTE: This line indicates an update has been released for the listed product(s). At times this might be only a partial fix. If you have questions please reach out to maintenance coordination.
Comment 19 Charles Arnold 2021-01-22 18:56:02 UTC
Backported and released to 11-SP3.
Comment 20 Gabriele Sonnu 2022-05-05 11:36:41 UTC
Done.